# Detect the distribution in use
%global __despace /usr/bin/head -n 1 | /usr/bin/tr -d '[:space:]' | %{__sed} -e 's/[(].*[)]//g'
%global __lower4 /usr/bin/cut -c 1-4 | /usr/bin/tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(%{__sed} -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(%{__sed} -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS & White Box as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "wbel"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global perl_version %(eval "`%{__perl} -V:version`"; echo $version)
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)}
%{!?__id_u: %global __id_u %([ -x /bin/id ]&&echo /bin/id||([ -x /usr/bin/id ]&&echo /usr/bin/id||echo /bin/true)) -u}

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(%{__perl} -MTest::More -e 'printf "%d\\n", $Test::More::VERSION < 0.88 ? 1 : 0;' 2>/dev/null || echo 0)

# We don't really need ExtUtils::MakeMaker > 6.31
%global old_eumm %(%{__perl} -MExtUtils::MakeMaker -e 'printf "%d\\n", $ExtUtils::MakeMaker::VERSION < 6.31 ? 1 : 0;' 2>/dev/null || echo 0)

Name:		perl-Exception-Class
Version:	1.32
Release:	3.%{__distinit}%{__distvers}
Summary:	Module that allows you to declare real exception classes in Perl
License:	Artistic 2.0
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Exception-Class/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/Exception-Class-%{version}.tar.gz
Patch0:		perl-Exception-Class-1.31-old-Test::More.patch
Patch1:		perl-Exception-Class-1.32-stopwords.patch
Patch2:		perl-Exception-Class-1.31-old-EU::MM.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch
BuildRequires:	perl >= 3:5.8.1
BuildRequires:	perl(Class::Data::Inheritable) >= 0.02
BuildRequires:	perl(Devel::StackTrace) >= 1.20
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Test::EOL)
%if "%{perl_version}" != "5.8.0"
BuildRequires:	perl(Test::Kwalitee)
%endif
BuildRequires:	perl(Test::More) >= 0.46
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
BuildRequires:	perl(Test::Spelling), aspell-en
Requires:	perl(:MODULE_COMPAT_%{perl_version})

%description
Exception::Class allows you to declare exception hierarchies in your
modules in a "Java-esque" manner.

%prep
%setup -q -n Exception-Class-%{version}

# Another test suite converted to use done_testing
%if %{old_test_more}
%patch0 -p1
%endif

# Additional words spell checker needs to know about
%patch1 -p1

# We don't really need ExtUtils::MakeMaker >= 6.31
%if %{old_eumm}
%patch2 -p1
%endif

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} pure_install PERL_INSTALL_ROOT=%{buildroot}
/usr/bin/find %{buildroot} -type f -name .packlist -exec %{__rm} -f {} \;
/usr/bin/find %{buildroot} -depth -type d -exec /bin/rmdir {} 2>/dev/null \;
%{__chmod} -R u+w %{buildroot}

%check
LANG=en_US %{__make} test RELEASE_TESTING=1

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorlib}/Exception/
%{_mandir}/man3/Exception::Class.3pm*
%{_mandir}/man3/Exception::Class::Base.3pm*

%changelog
* Tue Mar 22 2011 Paul Howarth <paul@city-fan.org> - 1.32-3
- BR: perl(Test::Kwalitee)

* Mon Feb 14 2011 Paul Howarth <paul@city-fan.org> - 1.32-2
- Update stopwords patch - dictionary coverage in Rawhide appears to have gone
  down

* Tue Jun 29 2010 Paul Howarth <paul@city-fan.org> - 1.32-1
- Update to 1.32 (removed Test::Most dependency, which was causing a circular
  dependency chain [CPAN RT#58889])

* Mon Jun 28 2010 Paul Howarth <paul@city-fan.org> - 1.31-1
- Update to 1.31 (made it possible to use Exception::Class::Base without
  loading Exception::Class [CPAN RT#57269])
- Author tests are back from xt/ to t/
- Update stopwords and old-Test::More patches
- License changed to Artistic 2.0
- Package README
- BR: perl(Test::EOL) and perl(Test::NoTabs)
- Add patch to build with ExtUtils::MakeMaker < 6.31

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 1.30-3
- Rebuild for perl 5.12.1 in Rawhide

* Tue Jun  8 2010 Paul Howarth <paul@city-fan.org> - 1.30-2
- Fix dist tag for RHEL-6 Beta

* Mon Mar 22 2010 Paul Howarth <paul@city-fan.org> - 1.30-1
- Update to 1.30 (add ability to create lightweight exceptions - CPAN RT#54826)
- Drop build hack for perl 5.8.6 and earlier, no longer needed
- Add patch to support builds with Test::More < 0.88
- Don't need to fix permissions in %%prep any more
- Run extra author tests
- Add buildreqs perl(Test::Spelling) and aspell-en for spelling test

* Wed Nov 25 2009 Paul Howarth <paul@city-fan.org> - 1.29-2
- Import from Fedora

* Thu Jul 30 2009 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.29-1
- Upstream update (required by other packages, fix mass rebuild breakdowns)

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.26-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.26-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Dec 12 2008 Steven Pritchard <steve@kspei.com> 1.26-1
- Update to 1.26
- Bump Devel::StackTrace dependency to 1.20

* Thu May 31 2008 Steven Pritchard <steve@kspei.com> 1.24-1
- Update to 1.24
- Bump Devel::StackTrace dependency to 1.17
- Clean up to match current cpanspec output
- Improve Summary and description
- Build with Module::Build
- BR Test::Pod and Test::Pod::Coverage and define IS_MAINTAINER

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.23-6
- Rebuild for perl 5.10 (again)

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.23-5
- Rebuild against new perl

* Sat Dec 29 2007 Ralf Corsépius 1.23-4
- BR: perl(Test::More) (BZ 419631)
- Adjust License-tag

* Tue Apr 17 2007 Steven Pritchard <steve@kspei.com> 1.23-3
- Use fixperms macro instead of our own chmod incantation
- BR ExtUtils::MakeMaker

* Sat Sep 16 2006 Steven Pritchard <steve@kspei.com> 1.23-2
- Canonicalize Source0 URL
- Fix find option order
- Drop executable bit from Exception/Class.pm to avoid a rpmlint warning

* Fri Feb 03 2006 Steven Pritchard <steve@kspei.com> 1.23-1
- Update to 1.23

* Tue Jan 10 2006 Steven Pritchard <steve@kspei.com> 1.22-1
- Update to 1.22

* Mon Sep 05 2005 Steven Pritchard <steve@kspei.com> 1.21-3
- Remove explicit core module dependencies
- Add COPYING and Artistic

* Wed Aug 17 2005 Steven Pritchard <steve@kspei.com> 1.21-2
- Minor spec cleanup

* Tue Aug 16 2005 Steven Pritchard <steve@kspei.com> 1.21-1
- Specfile autogenerated
